package net.rumati.logging.muffero;

import java.util.Collections;
import java.util.Deque;
import java.util.LinkedList;
import java.util.List;
import net.rumati.logging.muffero.util.ConservativeInheritableThreadLocal;

class NDCManager
{
    private final ConservativeInheritableThreadLocal<Deque<String>> stacks = new ConservativeInheritableThreadLocal<Deque<String>>()
    {
        @Override
        protected Deque<String> create()
        {
            return new LinkedList<String>();
        }
    };

    NDCManager()
    {
    }

    void push(String key)
    {
        stacks.get(true).push(key);
    }

    String pop()
    {
        Deque<String> stack = stacks.get();
        if (stack != null && !stack.isEmpty()){
            String retv = stack.pop();
            if (stack.isEmpty()){
                stacks.remove();
            }
            return retv;
        }
        return null;
    }

    void clear()
    {
        stacks.remove();
    }

    void pop(String key)
    {
        while (true){
            String top = pop();
            if (top == null){
                break;
            }else if (top.equals(key)){
                break;
            }
        }
    }

    List<String> getCopyOfStack()
    {
        List<String> retv = new LinkedList<String>();
        Deque<String> stack = stacks.get();
        if (stack != null){
            retv.addAll(stack);
        }
        Collections.reverse(retv);
        return retv;
    }

    boolean contains(String key)
    {
        Deque<String> stack = stacks.get();
        if (stack == null){
            return false;
        }
        return stack.contains(key);
    }
}
