package net.rumati.logging.muffero;

/**
 * Represents the priority at which messages are logged.
 * @author Jesse Long
 */
public enum Priority
{
    TRACE,
    DEBUG,
    INFO,
    WARNING,
    ERROR,
    OFF;

    public boolean isMoreCriticalThan(Priority p)
    {
        return compareTo(p) > 0;
    }

    public boolean isLessCriticalThan(Priority p)
    {
        return compareTo(p) < 0;
    }
}
