package net.rumati.logging.muffero;

/**
 * An implementation of {@link LoggingErrorLogger} that prints error message to 
 * {@link System#err}.
 * @author Jesse Long
 */
public class StdErrLoggingErrorLogger
        implements LoggingErrorLogger
{
    /**
     * {@inheritDoc}
     * <p>
     * This implementation prints the error message and stack trace to {@link System#err}
     */
    public void logError(String message, Throwable t)
    {
        System.err.println("ERROR: " + message);
        if (t != null){
            t.printStackTrace(System.err);
        }
    }
}
