package net.rumati.logging.muffero.appender;

import net.rumati.logging.muffero.LogEvent;
import net.rumati.logging.muffero.Priority;

/**
 * A simple base implementation of an {@link Appender} that does not filter
 * {@link LogEvent}s. This class implements the {@link Appender#isPriorityEnabled(net.rumati.logging.muffero.Priority)}
 * method, always returns {@code true}.
 * @author Jesse Long
 */
public abstract class AbstractNonFilteringAppender
        implements Appender
{
    /**
     * {@inheritDoc }
     * <p>
     * This implementation always returns {@code true}
     * 
     * @param priority the {@link Priority} to be checked
     * @return whether or not this {@link Priority} is enabled 
     */
    public boolean isPriorityEnabled(String loggerName, Priority priority)
    {
        return true;
    }
}
