package net.rumati.logging.muffero.appender;

import java.io.IOException;
import java.io.Writer;
import net.rumati.logging.muffero.layout.Layout;
import net.rumati.logging.muffero.LogEvent;
import net.rumati.logging.muffero.LoggerContext;

public abstract class WriterAppender
    extends AbstractNonFilteringAppender
{
    protected abstract Writer getWriter()
        throws IOException;

    protected abstract Layout getLayout();

    public void append(LogEvent event)
    {
        String output = getLayout().format(event);
        Writer w = null;
        try {
            w = getWriter();
            synchronized (w){
                try {
                    w.write(output);
                    w.flush();
                }catch (IOException e){
                    LoggerContext.get().getLoggingErrorLogger().logError("Error writing to log", e);
                }
            }
        }catch (IOException e){
            LoggerContext.get().getLoggingErrorLogger().logError("Error getting writer for logging", e);
        }
    }
}
