package net.rumati.logging.muffero.appender.filter;

import net.rumati.logging.muffero.LogEvent;
import net.rumati.logging.muffero.NDC;
import net.rumati.logging.muffero.Priority;
import net.rumati.logging.muffero.appender.Appender;

public class NDCFilteredAppender
        implements Appender
{
    private final Appender wrappedAppender;
    private final String requiredKey;

    public NDCFilteredAppender(Appender wrappedAppender, String requiredKey)
    {
        this.wrappedAppender = wrappedAppender;
        this.requiredKey = requiredKey;
    }

    public boolean isPriorityEnabled(String loggerName, Priority priority)
    {
        if (NDC.contains(requiredKey)){
            return wrappedAppender.isPriorityEnabled(loggerName, priority);
        }else{
            return false;
        }
    }

    public void append(LogEvent event)
    {
        if (NDC.contains(requiredKey)){
            wrappedAppender.append(event);
        }
    }

    public void shutdown()
    {
        wrappedAppender.shutdown();
    }
}
